//+------------------------------------------------------------------+
//|                                    Leledc-SsrcForce_Mtf.mq4      |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

// modified by chriz : gave it a little smoothing
// added 2 buffers 

#property indicator_separate_window
#property indicator_buffers  4
#property indicator_color3   Lime
#property indicator_width3 2
#property indicator_color4 Red
#property indicator_width4 2
#property indicator_maximum 1.1
#property indicator_minimum -1.1

extern string BaseIndi="Leledc-SsrcforceFinal";
extern int TimeFrame=15;
extern int    SnakeRange   =13; 
extern int    FilterPeriod =21; 
extern double MartFiltr    =2;
extern int    PriceConst   =6; 
extern int MaPeriod=5;
extern int MaMode=3;
extern double LevelsCross=0.95;
extern int Countbars=300;

// added by chriz
extern int SmoothMTFPeriod = 10 ;
int SmoothMaMode = 0 ;
// end



double ExtMapBuffer1[];
double ExtMapBuffer2[];

// added by chriz
double ExtSmoothMapBuffer1[];
double ExtSmoothMapBuffer2[];
// end 

bool TurnedUp = false;
bool TurnedDown = false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
   int init()
   {
   
   //---- indicator line
      IndicatorBuffers(4);

      SetIndexStyle(0, DRAW_NONE);
      SetIndexStyle(1, DRAW_NONE);
      SetIndexBuffer(0,ExtMapBuffer1);
      SetIndexBuffer(1,ExtMapBuffer2);

// added by chriz      
      SetIndexBuffer(2,ExtSmoothMapBuffer1);
      SetIndexBuffer(3,ExtSmoothMapBuffer2);
      SetIndexStyle(2, DRAW_LINE);
      SetIndexStyle(3, DRAW_LINE);
// end
            
      SetLevelValue(0,LevelsCross);
      SetLevelValue(1,-LevelsCross);

      SetLevelValue(2,LevelsCross);
      SetLevelValue(3,-LevelsCross);
      
   //---- name for DataWindow and indicator subwindow label   
      switch(TimeFrame)
      {
         case 1 : string TimeFrameStr="Period_M1"; break;
         case 5 : TimeFrameStr="Period_M5"; break;
         case 15 : TimeFrameStr="Period_M15"; break;
         case 30 : TimeFrameStr="Period_M30"; break;
         case 60 : TimeFrameStr="Period_H1"; break;
         case 240 : TimeFrameStr="Period_H4"; break;
         case 1440 : TimeFrameStr="Period_D1"; break;
         case 10080 : TimeFrameStr="Period_W1"; break;
         case 43200 : TimeFrameStr="Period_MN1"; break;
         default : TimeFrameStr="Current Timeframe";
      } 
   }
//----

   return(0);
 
   int start()
   {
      SetIndexDrawBegin(0,Bars-Countbars);
      SetIndexDrawBegin(1,Bars-Countbars);
      SetIndexDrawBegin(2,Bars-Countbars);
      SetIndexDrawBegin(3,Bars-Countbars);      
      
      datetime TimeArray[];
      int    i,shift,limit,limit2,y=0,LastSignal;
    
   // Plot defined timeframe on to current timeframe   
      ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
      int counted_bars = IndicatorCounted();
      limit=Countbars-counted_bars;
      if (i> limit2) 
      limit2= i;    
      if (limit2 <Countbars- 1)
      limit =Countbars- 1;  
      for(i=0;i<limit;i++) {
         ExtMapBuffer1[i]=EMPTY_VALUE;
         ExtMapBuffer2[i]=EMPTY_VALUE;
         ExtSmoothMapBuffer1[i]=EMPTY_VALUE;
         ExtSmoothMapBuffer2[i]=EMPTY_VALUE;
      }
      for(i=0,y=0;i<limit;i++)
      {  
         if (Time[i]<TimeArray[y]) y++;    
         ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,BaseIndi,SnakeRange,FilterPeriod,MartFiltr,PriceConst,MaPeriod,MaMode,LevelsCross,Countbars,0,y);
         ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,BaseIndi,SnakeRange,FilterPeriod,MartFiltr,PriceConst,MaPeriod,MaMode,LevelsCross,Countbars,1,y);      
      }
      
      // added by chriz
      for(i=limit; i>=0; i--) {
         ExtSmoothMapBuffer1[i]=iMAOnArray( ExtMapBuffer1, 0, SmoothMTFPeriod,0,SmoothMaMode ,i);
         ExtSmoothMapBuffer2[i]=iMAOnArray( ExtMapBuffer2, 0, SmoothMTFPeriod,0,SmoothMaMode ,i);
      }            
      // end
      
      if (i> limit2) 
         limit2= i;
  
      return(0);
   }

//+------------------------------------------------------------------+